var cgdg;
var local_config;
var random_config;
var str;
var config;
var domain;

function initPosition() {
    cc.log("initPosition");
    cgdg.scaleX = (cc.winSize.width / cgdg.designSize.width);
    cgdg.scaleY = (cc.winSize.height / cgdg.designSize.height);
    cgdg.minScale = Math.min(cgdg.scaleX, cgdg.scaleY);
    cgdg.maxScale = Math.max(cgdg.scaleX, cgdg.scaleY);
    cgdg.centerX = (cc.winSize.width / 2);
    cgdg.centerY = (cc.winSize.height / 2);
}

function removeDialog(target, tag) {

    if ((target == null) || cc.isUndefined(target) || !(target)) {
        return;
    }
    try {
        target.removeChildByTag(tag);
        cc.director.getRunningScene().removeChildByTag(tag);
    } catch (err) {

        mlog(err);
    }

}

function showDialogConfirm(target, event, confirm, title, autoClose, time) {

    // target,event,confirm,title,autoClose,time,dialog
    removeDialog(target, cgdg.TAG_DIALOG_CONFIRM);
    var dialog = new CGDGDialogLayer();
    dialog.createDialogConfirm(true, event, confirm, title, autoClose, time);
    target.addChild(dialog, 10000, cgdg.TAG_DIALOG_CONFIRM);

}

function showDialogRetry(target, event, confirm, title, autoClose, time) {

    // target,event,confirm,title,autoClose,time,dialog
    removeDialog(target, cgdg.TAG_DIALOG_RETRY);
    if (!(target)) {
        return undefined;
    }
    var dialog = new CGDGDialogLayer();
    dialog.createDialogRetry(event, confirm, title, autoClose, time);
    target.addChild(dialog, 10000, cgdg.TAG_DIALOG_RETRY);

}

function showDialogNotify(target, notifyContent, title, autoClose, time) {

    // target,notifyContent,title,autoClose,time,dialog
    var dialog = new CGDGDialogLayer();
    dialog.createDialogNotify(notifyContent, title, autoClose, time);
    target.addChild(dialog, 10000, cgdg.TAG_DIALOG_NOTIFY);
    return dialog;
}

function showToast(target, notifyContent, time, isError) {

    //,dialog

    removeDialog(target, cgdg.TAG_TOAST);
    var dialog = new Toast(notifyContent, time, isError);
    dialog.setPosition(cc.p((cc.winSize.width / 2), (cc.winSize.height / 2)));
    dialog.setScale(Math.min((cc.winSize.width / 1920), (cc.winSize.height / 1080)));
    cc.director.getRunningScene().addChild(dialog, 10001, cgdg.TAG_TOAST);

}

function waiting(target, title) {

    // target,title,dialog
    removeWaiting(target);
    var dialog = new CGDGDialogLayer();
    if ((title == undefined)) {
        dialog.createDialogWaiting("");
    } else {
        dialog.createDialogWaiting(title);
    }

    cc.director.getRunningScene().addChild(dialog, 100000, cgdg.TAG_DIALOG_WAITING);

}

function waiting1(target, title) {

    // target,title,dialog
    removeWaiting(target);
    var dialog = new CGDGDialogLayer();
    if ((title == undefined)) {
        dialog.createDialogWaiting1("");
    } else {
        dialog.createDialogWaiting1(title);
    }

    target.addChild(dialog, 100000, cgdg.TAG_DIALOG_WAITING);

}

function removeWaiting(target) {
    this.removeDialog(target, cgdg.TAG_DIALOG_WAITING);
}

function getTitle(gameID) {

    // gameID,title

    var title = "";
    switch (gameID) {
        case cgdg.GAME_BACAY:
            title = cgdg.STR_TITLE_BA_CAY;
            break;
        case cgdg.GAME_TALA:
            title = cgdg.STR_TITLE_TA_LA;
            break;
        case cgdg.GAME_TLMN_DL:
            title = cgdg.STR_TITLE_TLMN;
            break;
        case cgdg.GAME_TLMN_NAT:
            title = cgdg.STR_TITLE_TLMN;
            break;
        case cgdg.GAME_TLMB:
            title = cgdg.STR_TITLE_TLMB;
            break;
        case cgdg.GAME_SAMLOC:
            title = cgdg.STR_TITLE_SAM_LOC;
            break;
        case cgdg.GAME_MAUBINH:
            title = cgdg.STR_TITLE_MAU_BINH;
            break;
        case cgdg.GAME_XITO:
            title = cgdg.STR_TITLE_XI_TO;
            break;
        case cgdg.GAME_LIENG:
            title = cgdg.STR_TITLE_LIENG;
            break;
        case cgdg.GAME_XOCDIA:
            title = cgdg.STR_TITLE_XOC_DIA;
            break;
        case cgdg.GAME_POKER:
            title = cgdg.STR_TITLE_POKER;
            break;
        case cgdg.GAME_CHAN:
            title = cgdg.STR_TITLE_CHAN;
            break;
        case cgdg.GAME_VIDEOPOKER:
            title = cgdg.STR_TITLE_VIDEO_POKER;
            break;
        case cgdg.GAME_TLMN_DL_SOLO:
            title = cgdg.STR_TITLE_TLMN_SOLO;
            break;
        case cgdg.GAME_SAMLOC_SOLO:
            title = cgdg.STR_TITLE_SAM_LOC_SOLO;
            break;
        default:
            title = cgdg.STR_TITLE_GAME;
    }
    return title;

}

function convertMoneyToChip(money) {

    // money,layoutChip,imgChip100M,imgChip10M,imgChip1M,imgChip100K,imgChip10K,imgChip1K,imgChip100,chip100M,chip10M,chip1M,chip100K,chip10K,chip1K,chip100,i,spriteChip100M,spriteChip10M,spriteChip1M,spriteChip100K,spriteChip10K,spriteChip1K,spriteChip100
    if ((money <= 0)) {
        return null;
    }
    var layoutChip = ccs.load("res/chipLayout.json").node;
    var imgChip100M = ccui.helper.seekWidgetByName(layoutChip, "imgChip100M");
    var imgChip10M = ccui.helper.seekWidgetByName(layoutChip, "imgChip10M");
    var imgChip1M = ccui.helper.seekWidgetByName(layoutChip, "imgChip1M");
    var imgChip100K = ccui.helper.seekWidgetByName(layoutChip, "imgChip100K");
    var imgChip10K = ccui.helper.seekWidgetByName(layoutChip, "imgChip10K");
    var imgChip1K = ccui.helper.seekWidgetByName(layoutChip, "imgChip1K");
    var imgChip100 = ccui.helper.seekWidgetByName(layoutChip, "imgChip100");
    var chip100M = Math.floor((money / 100000000));
    var chip10M = Math.floor(((money % 100000000) / 10000000));
    var chip1M = Math.floor(((money % 10000000) / 1000000));
    var chip100K = Math.floor(((money % 1000000) / 100000));
    var chip10K = Math.floor(((money % 100000) / 10000));
    var chip1K = Math.floor(((money % 10000) / 1000));
    var chip100 = Math.floor(((money % 1000) / 100));
    if ((chip100M > 0)) {
        var i = 0;
        while ((i < chip100M)) {
            var spriteChip100M = new cc.Sprite("res/common/100m.png");
            spriteChip100M.setPosition(imgChip100M.getPosition().x, (imgChip100M.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip100M);
            i++;
        }
    }
    if ((chip10M > 0)) {
        var i = 0;
        while ((i < chip10M)) {
            var spriteChip10M = new cc.Sprite("res/common/10m.png");
            spriteChip10M.setPosition(imgChip10M.getPosition().x, (imgChip10M.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip10M);
            i++;
        }
    }
    if ((chip1M > 0)) {
        var i = 0;
        while ((i < chip1M)) {
            var spriteChip1M = new cc.Sprite("res/common/1m.png");
            spriteChip1M.setPosition(imgChip1M.getPosition().x, (imgChip1M.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip1M);
            i++;
        }
    }
    if ((chip100K > 0)) {
        var i = 0;
        while ((i < chip100K)) {
            var spriteChip100K = new cc.Sprite("res/common/100k.png");
            spriteChip100K.setPosition(imgChip100K.getPosition().x, (imgChip100K.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip100K);
            i++;
        }
    }
    if ((chip10K > 0)) {
        var i = 0;
        while ((i < chip10K)) {
            var spriteChip10K = new cc.Sprite("res/common/10k.png");
            spriteChip10K.setPosition(imgChip10K.getPosition().x, (imgChip10K.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip10K);
            i++;
        }
    }
    if ((chip1K > 0)) {
        var i = 0;
        while ((i < chip1K)) {
            spriteChip1K = new cc.Sprite("res/common/1k.png");
            spriteChip1K.setPosition(imgChip1K.getPosition().x, (imgChip1K.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip1K);
            i++;
        }
    }
    if ((chip100 > 0)) {
        var i = 0;
        while ((i < chip100)) {
            var spriteChip100 = new cc.Sprite("res/common/100.png");
            spriteChip100.setPosition(imgChip100.getPosition().x, (imgChip100.getPosition().y + (2 * i)));
            layoutChip.addChild(spriteChip100);
            i++;
        }
    }
    return layoutChip;

}

function convertNumberToKM(val) {

    //val,sign,n,text
    if ((Math.abs(val) >= 1000000)) {
        var sign = (val < 0) ? 1 : 0;
        val = Math.abs(val);
        var n = (val / 1000000);
        var text = (formatNumber(n) + "M");
        if (sign) {
            text = ("-" + text);
        }
        return text;
    } else {
        return convertNumberToK(val);
    }
}

function find(parentNode, childName) {

    //parentNode,childName
    return ccui.helper.seekWidgetByName(parentNode, childName);

}

function shuffleArray(a) {

    // a,i,t,j
    for (var i = a.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        var temp = a[i];
        a[i] = a[j];
        a[j] = temp;
    }
    return a;
}

function decode_base64(s) {
    // TODO
    //s,e,i,k,v,r,w,n,b,c,x,l,o   
    var e = {},
        i, k, v = [],
        r = '',
        w = String.fromCharCode;
    var n = [
        [65, 91],
        [97, 123],
        [48, 58],
        [43, 44],
        [47, 48]
    ];

    for (z in n) {
        for (i = n[z][0]; i < n[z][1]; i++) {
            v.push(w(i));
        }
    }
    for (i = 0; i < 64; i++) {
        e[v[i]] = i;
    }

    for (i = 0; i < s.length; i += 72) {
        var b = 0,
            c, x, l = 0,
            o = s.substring(i, i + 72);
        for (x = 0; x < o.length; x++) {
            c = e[o.charAt(x)];
            b = (b << 6) + c;
            l += 6;
            while (l >= 8) {
                r += w((b >>> (l -= 8)) % 256);
            }
        }
    }
    return r;
}
cgdg = cgdg || {};
cgdg.DOMAIN = ["res-247.cr7.sbs"];
local_config = cc.sys.localStorage.getItem("config");
random_config = cc.sys.localStorage.getItem("random_config");
mlog(((("local_config:" + local_config) + " random_config:") + random_config));

if (local_config && (local_config != "null")) {
    try {
        str = local_config.toString();
        str = (str.substr(0, 2) + str.substr(5, str.length));
        config = decode_base64(str).trim();
        config = config.replace(/\0[\s\S]*$/, "");
        mlog("config=", config);
        domain = config.split(",");
        mlog("domain:", domain);
        cgdg.DOMAIN = domain;
        mlog(" cgdg domain:", cgdg.DOMAIN);
      
    } catch (err) {
        
    }

}
cgdg.DOMAIN_IP = [];
if ((random_config == "true")) {
    cgdg.DOMAIN = shuffleArray(cgdg.DOMAIN);
}
cgdg.DOMAIN = cgdg.DOMAIN.concat(cgdg.DOMAIN_IP);
mlog("domain1:", cgdg.DOMAIN);
mlog("domainip:", cgdg.DOMAIN_IP);

cgdg.LINK_SERVER2 = (("https://" + cgdg.DOMAIN[0]) + "/app/");

cgdg.SERVER_DOMAIN = "https://res-247.cr7.sbs";
cgdg.LINK_ACCOUNT_INFO = "https://mobile.kuteoonline.club";
cgdg.LINK_SERVER = (("https://" + cgdg.DOMAIN[0]) + "/eppgame/");

cgdg.URL_GAME_INFO = (cgdg.LINK_SERVER2 + "gameInfo.json");
if (!(cgdg.VERSION_STORE)) {
    cgdg.URL_GATE_INFO = (((cgdg.LINK_SERVER2 + "gateInfo_") + cgdg.os) + "_out.json");
} else if ((cgdg.os == "ios")) {
    cgdg.URL_GAME_INFO = (cgdg.LINK_SERVER2 + "gameInfo_ios.json");
}
cgdg.URL_GATE_INFO = (((cgdg.LINK_SERVER2 + "gateInfo_") + cgdg.os) + ".json");
cgdg.GAMEINFO_URL = (cgdg.LINK_SERVER + "0/gameInfo.json");
cgdg.TABLE_VALUE_URL = (cgdg.LINK_SERVER + "tableValue.json");
mlog(("update cgdg.GAMEINFO_URL :" + cgdg.GAMEINFO_URL));
mlog(("update cgdg.URL_GATE_INFO :" + cgdg.URL_GATE_INFO));
cgdg.COOKIE = "Cookie:";
cgdg.DOMAIN_INDEX = 0;
cgdg.NEW_DOMAIN = "";
cgdg.OLD_DOMAIN = "";
cgdg.GAME_TYPE = {
    SLOT: 1,
    ALL: 2,
    CARD: 3,
    CASINO: 4,
    SKILL: 5,
    MINIGAME: 6
};
cgdg.BA_CAY = 1;
cgdg.TA_LA = 3;
cgdg.XI_TO = 5;
cgdg.TLMN_DEMLA = 7;
cgdg.MAU_BINH = 9;
cgdg.TLMN_NHATANTAT = 27;
cgdg.POKER = 13;
cgdg.SAM_LOC = 15;
cgdg.LIENG = 17;
cgdg.CHAN = 19;
cgdg.XOC_DIA = 25;
cgdg.VIDEO_POKER = 29;
cgdg.TLMN_DEMLA_SOLO = 33;
cgdg.SAM_LOC_SOLO = 35;
cgdg.GLOBAL = 0;
cgdg.GAME_BACAY = 1;
cgdg.GAME_TALA = 2;
cgdg.GAME_TLMN_DL = 3;
cgdg.GAME_TLMN_NAT = 4;
cgdg.GAME_TLMB = 5;
cgdg.GAME_SAMLOC = 6;
cgdg.GAME_MAUBINH = 7;
cgdg.GAME_XITO = 8;
cgdg.GAME_LIENG = 9;
cgdg.GAME_XOCDIA = 10;
cgdg.GAME_POKER = 11;
cgdg.CHAT_LOBBY = 12;
cgdg.CHAT_CARD_GAME = 30;
cgdg.GAME_CHAN = 14;
cgdg.GAME_TAIXIU = 15;
cgdg.GAME_VIDEOPOKER_MINI = 16;
cgdg.GAME_FOOTBALL_MINI = 17;
cgdg.GAME_VIDEOPOKER = 22;
cgdg.EVENT = 24;
cgdg.GAME_HILO = 25;
cgdg.GAME_TLMN_DL_SOLO = 26;
cgdg.GAME_SAMLOC_SOLO = 27;
cgdg.GAME_KIMCUONG_MINI = 28;
cgdg.GAME_TIENCA = 116;
cgdg.GAME_DAOVANG = 219;
cgdg.GAME_BANCA = 119;
cgdg.GAME_FRUIT = 118;
cgdg.GAME_KONG = 221;
cgdg.GAME_MONSTER = 29;
cgdg.GATE_ID = 0;
cgdg.MINIGAME_TAIXIU_ID = 1001;
cgdg.MINIGAME_VIDEOPOKER_ID = 1002;
cgdg.MINIGAME_HILO_ID = 1003;
cgdg.MINIGAME_CANDY_ID = 1005;
cgdg.MINIGAME_VONGQUAY_ID = 1006;
cgdg.MINIGAME_MONSTER_ID = 1007;
cgdg.MINIGAME_CHUADAO_ID = 1008;
cgdg.MINIGAME_LISTGAME = 1999;
cgdg.COLOR_MONEY_WIN = new cc.color(242, 236, 4);
cgdg.COLOR_MONEY_LOST = new cc.color(236, 19, 88);
cgdg.COLOR_WHITE = new cc.color(255, 255, 255);
cgdg.COLOR_YELLOW = new cc.color(255, 255, 0);
cgdg.COLOR_BLACK = new cc.color(0, 0, 0);
cgdg.COLOR_RED = new cc.color(255, 0, 0);
cgdg.COLOR_BLUE = new cc.color(41, 76, 171);
cgdg.COLOR_ORANGE = new cc.color(233, 156, 0);
cgdg.COLOR_BROWN = new cc.color(167, 41, 43);
cgdg.COLOR_PURPLE = new cc.color(146, 56, 156);
cgdg.COLOR_GREEN = new cc.color(86, 157, 23);
cgdg.COLOR_INPUT = new cc.color(255, 255, 255);
cgdg.COLOR_INPUT_PH = new cc.color(127, 127, 127);
cgdg.scaleX = 0;
cgdg.scaleY = 0;
cgdg.centerX = 0;
cgdg.centerY = 0;
cgdg.minScale = 0;
cgdg.maxScale = 0;
cgdg.designSize = cc.size(1136, 640);